#include <stdio.h>
#include <stdbool.h>

bool parse_values(const char s[],  // La chaîne à segmenter
                  int values[3]) { // Les valeurs qu'on stocke
    // Une fonction très pratique: sscanf (voir man sscanf)
    // Astuce: on ajoute une quatrième valeur %c pour vérifier s'il y a un
    // caractère de trop (trailing char) mais on ne s'y intéresse pas
    char trailing;
    int num_parsed = sscanf(s,            // La chaîne à traiter
                            "%d,%d,%d%c", // Le format espéré
                            &values[0],   // Le premier %d
                            &values[1],   // Le deuxième %d
                            &values[2],   // Le troisième %d
                            &trailing);   // Le caractère de fin
    // On souhaite que le dernier caractère ne soit pas là
    return num_parsed == 3;
}

int main(int argc, char *argv[]) {
    // Note: pour compléter la solution, il vous reste à adapter le code en
    // passant argv[1] comme premier argument de la fonction parse_values
    int values[3];
    if (parse_values("1,2,3", values))
        printf("values = {%d, %d, %d}\n", values[0], values[1], values[2]);
    if (parse_values("-4,25,+13", values))
        printf("values = {%d, %d, %d}\n", values[0], values[1], values[2]);
    if (parse_values("-4,25,+13a", values))
        printf("Ne devrait pas arriver");
    else
        printf("Le caractère final 'a' pose problème");
    printf("\n");
    return 0;
}
