#include <stdio.h>
#include <string.h>

#define MAX_LENGTH 100

void initialize_dist(unsigned int *dist) {
    for (unsigned int i = 0; i < MAX_LENGTH; ++i)
        dist[i] = 0;
}

void load_dist(FILE *file, unsigned int *dist) {
    char buffer[MAX_LENGTH + 1];
    while (fgets(buffer, MAX_LENGTH, file)) {
        unsigned int l = strlen(buffer) - 1;
        ++dist[l];
    }
}

void print_dist(const unsigned int *dist) {
    for (unsigned int i = 0; i < MAX_LENGTH; ++i)
        if (dist[i] != 0)
            printf("%d %d\n", i, dist[i]);
}

int main(int argc, char *argv[]) {
    unsigned int dist[MAX_LENGTH];
    initialize_dist(dist);
    if (argc == 2) {
        FILE *file = fopen(argv[1], "r");
        if (!file) {
            fprintf(stderr, "Error: could not open file\n");
            return 1;
        }
        load_dist(file, dist);
        fclose(file);
    } else if (argc == 1) {
        load_dist(stdin, dist);
    }
    print_dist(dist);
    return 0;
}
