#include <stdio.h>

#define MAX_N 1000

unsigned long long fibonacci(unsigned int n) {
    // Le tableau f contient les MAX_N premières valeurs
    // On l'initialise avec {1,1,0,0,0,0,...}
    static unsigned long long f[MAX_N] = {1, 1};
    if (n >= MAX_N)
        // Tableau pas assez grand, on y va naïvement
        return fibonacci(n - 1) + fibonacci(n - 2);
    if (f[n] == 0) {
        // Tableau assez grand, on mémoïse
        f[n] = fibonacci(n - 1) + fibonacci(n - 2);
    }
    return f[n];
}

int main(void) {
    for (unsigned int n = 0; n < 40; ++n) {
        printf("%lld ", fibonacci(n));
    }
    printf("\n");
    return 0;
}
